<template src="./template.html"></template>

<script lang="ts">
import { Component, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
var momentz = require("moment-timezone");
var moment = require("moment");
//@ts-ignore
import jsonCountry from "@/locales/countryCode.json";
//@ts-ignore
import jsonProvince from "@/locales/provinceCode.json";
import _, { isBuffer } from "lodash";
import { api } from "~/common/constaint";
//@ts-ignore
import listCountry from "@/locales/listCountry.json";
@Component({})
export default class SellerOrdersComponent extends Vue {
  config = {
    page: 1,
    limit: 25,
    search: "",
    orderCode: "",
    email: "",
    domain: "",
    priceFrom: "",
    priceTo: "",
  };
  totalPage = 0;
  page = 1;
  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];
  loadingTable = false;

  panelFilter = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = momentz().endOf("day").format("YYYY-MM-DD");
  exportData = false;
  drawer = false;
  listStatus = [
    {
      name: "All",
      value: "",
    },
    {
      name: "Processing",
      value: "processing",
    },
    {
      name: "Done",
      value: "done",
    },
    {
      name: "Fulfilled",
      value: "fulfilled",
    },
    {
      name: "Canceled",
      value: "canceled",
    },
  ];
  status = "";
  listOrder = [];
  listAllOrder = [];

  orderDetail: any = {};

  selectedAll = false;
  listOrderId = [];

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  json_fields = {
    "Order Name": "orderName",
    Sku: "sku",
    "Product Name": "productName",
    "Variant Name": "variantName",
    Quantity: "quantity",
    "Item Status": "itemStatus",
    "Delivery Status": "deliveryStatus",
    "Last Status Updated At": "lastStatusUpdatedAt",
    "Paid At": "paidAt",
    "Processing At": "progressingAt",
    "Fulfilled At": "fulfilledAt",
    "Tracking Number": "trackingNumber",
    "Tracking Status": "trackingStatus",
    "Unit Price": "unitPrice",
    Subtotal: "subTotal",
    "Shipping Price": "shippingPrice",
    "Discount Price": "discountPrice",
    "Total Amount": "totalAmount",
    Refund: "refund",
    "Buyer Name": "buyerName",
    Email: "email",
    "Shipping Address 1": "shippingAddress1",
    "Shipping Address 2": "shippingAddress2",
    "Shipping Phone": "shippingPhone",
    "Shipping City": "shippingCity",
    "Shipping Zip": "shippingZip",
    "Shipping Province": "shippingProvince",
    "Shipping Country": "shippingCountry",
    "Shipping Country Code": "shippingCountryCode",
    "Shipping Province Code": "shippingProvinceCode",
    "Payment Gateway ID": "paymentGateWayId",
    "Gateway Name": "gatewayName",
    "Gateway Type": "gatewayType",
    Domain: "domain",
    "Transaction Id": "transactionId",
  };
  json_data: any = [];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get totalPrice() {
    return (
      this.orderDetail.total +
      this.orderDetail.shipping -
      this.orderDetail.discount -
      (this.orderDetail.tip || 0)
    );
  }

  calcTotalPrice(order: any) {
    return order.total + order.shipping - order.discount - (order.tip || 0);
  }

  fetchData() {
    this.json_data = [];
    if (this.listOrderId.length) {
      for (let id of this.listOrderId) {
        const findOrder: any = this.listOrder.find(
          (order: any) => order._id === id
        );
        if (findOrder) {
          this.onParseListExport(findOrder);
        }
      }
    } else {
      for (let order of this.listAllOrder) {
        if (order) {
          this.onParseListExport(order);
        }
      }
    }

    this.$pushNotification.success("Export successfully");
    this.exportData = false;
  }

  onParseListExport(findOrder?: any) {
    console.log("findOrder :>> ", findOrder);
    let listVariant;
    let listProduct;
    let listQuantity;
    let listSku;
    let listSlug;
    if (findOrder?.listSelectedProductId?.length) {
      listVariant = findOrder.listSelectedProductId
        .map((product: any) => product?.listValue)
        .join("\n");
      listProduct = findOrder.listSelectedProductId
        .map((product: any) => product?.productName)
        .join("\n");
      listQuantity = findOrder.listSelectedProductId
        .map((product: any) => product?.quantity)
        .join("\n");
      listSku = findOrder.listSelectedProductId
        .map((product: any) => product?.sku)
        .join("\n");
      listSlug = findOrder.listSelectedProductId
        .map((product: any) => product?.slug)
        .join("\n");
    }

    if (findOrder && findOrder.shippingAddress) {
      let payment = "";
      if (findOrder?.paypal?.paymentID) {
        payment = "Paypal";
      } else if (findOrder?.stripe) {
        payment = "Stripe";
      }
      let itemStatus = "";
      if (findOrder.orderStatus === "processing") itemStatus = "Processing";
      else if (findOrder.orderStatus === "pending") itemStatus = "Pending";
      else if (findOrder.orderStatus === "canceled") itemStatus = "Canceled";
      else if (findOrder.orderStatus === "fulfilled") itemStatus = "Fulfilled";

      let deliveryStatus = "";
      if (findOrder.shippingStatus === 1) deliveryStatus = "TRACKING_PAID";
      else if (findOrder.shippingStatus === 2)
        deliveryStatus = "TRACKING_AVAILABLE";
      else if (findOrder.shippingStatus === 3)
        deliveryStatus = "TRACKING_ONLINE";
      else if (findOrder.shippingStatus === 4)
        deliveryStatus = "TRACKING_DELIVERY&GUARANTEE";

      const {
        address,
        apartment,
        city,
        companyName,
        country,
        email,
        firstName,
        lastName,
        phoneNumber,
        state,
        zipCode,
      } = findOrder.shippingAddress;
      const { listSelectedProductId } = findOrder;
      const findCountry = listCountry.find(
        (qg: any) => qg.code === country || qg.name === country
      );
      if (listSelectedProductId.length === 1) {
        //@ts-ignore
        this.json_data.push({
          orderName: findOrder.orderCode,
          sku: listSku,
          productName: listProduct || "",
          variantName: listVariant || "",
          quantity: listQuantity || "",
          itemStatus,
          deliveryStatus,
          lastStatusUpdatedAt:
            findOrder.updatedAt &&
            this.$utils.formatDateCreatedAt(findOrder.updatedAt),
          paidAt:
            findOrder.createdAt &&
            this.$utils.formatDateCreatedAt(findOrder.createdAt),
          progressingAt:
            findOrder.processingDate &&
            this.$utils.formatDateCreatedAt(findOrder.processingDate),
          fulfilledAt: findOrder.fulfilledAt || "",
          trackingNumber: findOrder.trackingNumber,
          trackingStatus: "",
          unitPrice: findOrder?.listSelectedProductId[0]?.price || 0,
          subTotal: findOrder.subTotal,
          shippingPrice: findOrder.shipping,
          discountPrice: findOrder.discount,
          totalAmount: findOrder.total,
          refund: 0,
          buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
          email: findOrder.shippingAddress.email,
          shippingAddress1: address,
          shippingAddress2: apartment,
          shippingPhone: phoneNumber,
          shippingCity: city,
          shippingZip: zipCode,
          shippingProvince: this.findProvinceCode(state),
          shippingCountry: findCountry?.name || country,
          shippingCountryCode:
            findCountry?.code || this.findCountryCodeByCountry(country),
          shippingProvinceCode: state || "",
          paymentGateWayId: "",
          gatewayName: findOrder?.paymentId?.name || "",
          gatewayType: payment,
          domain: findOrder?.storeId?.domain || "",
          transactionId:
            findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
        });
      } else {
        for (let i = 0; i < listSelectedProductId.length; i++) {
          const subTotal = _.sumBy(listSelectedProductId, "price");
          const product = listSelectedProductId[i];
          //@ts-ignore
          this.json_data.push({
            orderName: findOrder.orderCode,
            sku: product.sku || "",
            productName: product.productName || "",
            variantName: product.listValue.join(",") || "",
            quantity: product.quantity,
            itemStatus,
            deliveryStatus,
            lastStatusUpdatedAt:
              findOrder.updatedAt &&
              this.$utils.formatDateCreatedAt(findOrder.updatedAt),
            paidAt:
              findOrder.createdAt &&
              this.$utils.formatDateCreatedAt(findOrder.createdAt),
            progressingAt:
              findOrder.processingDate &&
              this.$utils.formatDateCreatedAt(findOrder.processingDate),
            fulfilledAt: findOrder.fulfilledAt || "",
            trackingNumber: findOrder.trackingNumber,
            trackingStatus: "",
            unitPrice: product?.price || 0,
            subTotal: i === 0 ? subTotal : 0,
            shippingPrice: i === 0 ? findOrder.shipping : 0,
            discountPrice: i === 0 ? findOrder.discount : 0,
            totalAmount: i === 0 ? findOrder.total : 0,
            refund: 0,
            buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
            email: findOrder.shippingAddress.email,
            shippingAddress1: address,
            shippingAddress2: apartment,
            shippingPhone: phoneNumber,
            shippingCity: city,
            shippingZip: zipCode,
            shippingProvince: this.findProvinceCode(state),
            shippingCountry: findCountry?.name || country,
            shippingCountryCode:
              findCountry?.code || this.findCountryCodeByCountry(country),
            shippingProvinceCode: state || "",
            paymentGateWayId: "",
            gatewayName: findOrder?.paymentId?.name || "",
            gatewayType: payment,
            domain: findOrder?.storeId?.domain,
            transactionId:
              findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
          });
        }
      }
    }
  }
  loadingExport = false;
  async onExportFile() {
    if (!this.listOrderId.length) {
      await this.onGetAllList();
    }
    //@ts-ignore
    this.$refs.export.$el.click();
  }

  async onGetAllList() {
    try {
      this.loadingExport = true;
      let config: any = this.config;
      if (this.status) {
        config["orderStatus"] = this.status;
      }
      config.priceFrom = config.priceFrom;
      config.priceTo = config.priceTo;
      const response = await this.$api.sellerOrder.exportList({
        ...config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.listAllOrder = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingExport = false;
    }
  }

  mounted() {
    this.onGetListOrder();
  }
  total = 0;
  async onGetListOrder() {
    try {
      this.total = 0;
      this.listOrderId = [];
      this.loadingTable = true;
      this.$store.commit("setting/setTime", {
        dateStart: this.dateStart,
        dateEnd: this.dateEnd,
      });
      let config: any = this.config;
      if (this.status) {
        config["orderStatus"] = this.status;
      }
      config.priceFrom = config.priceFrom;
      config.priceTo = config.priceTo;
      const response = await this.$api.sellerOrder.list({
        ...config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data?.data) {
        const { total } = response.data;
        this.total = total;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listOrder = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListOrder();
  }

  openDialogDetail(order: any) {
    this.orderDetail = order;
    this.drawer = true;
  }

  resetField() {
    this.config = {
      page: 1,
      limit: 25,
      search: "",
      orderCode: "",
      email: "",
      domain: "",
      priceFrom: "",
      priceTo: "",
    };
    this.onGetListOrder();
  }

  findCountryCodeByCountry(country: string) {
    for (let item in jsonCountry) {
      if (jsonCountry[item] === country) {
        return item;
      }
    }
  }

  findProvinceCode(province: string) {
    const findProvince = jsonProvince.find(
      (item: any) => item.abbreviation === province
    );
    if (findProvince) {
      return findProvince.name;
    }
    return province;
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listOrderId = [...this.listOrderId];
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id)
        //@ts-ignore
        .filter((id) => !listOrderId.includes(id));
      //@ts-ignore
      this.listOrderId = [...listOrderId, ...selectedCurrentOrder];
    } else {
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id);
      this.listOrderId = this.listOrderId.filter(
        (c) => !selectedCurrentOrder.includes(c)
      );
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListOrder();
  }

  @Watch("status")
  changedStatus() {
    this.listOrderId = [];
    this.selectedAll = false;
    this.resetField();
  }

  @Watch("dateStart")
  changedDateStart() {
    this.onGetListOrder();
  }

  @Watch("dateEnd")
  changedDateEnd() {
    this.onGetListOrder();
  }
}
</script>

<style></style>
